/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/dynpmc/os.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_os.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/dynpmc/os.pmc"
/*
Copyright (C) 2001-2011, Parrot Foundation.

=head1 NAME

src/pmc/os.pmc - Files and Directories PMC

=head1 DESCRIPTION

C<OS> is a singleton class which provides access to the filesystem
files and directories.

=head2 Methods

=over 4

=cut

*/

#if defined(_MSC_VER)
#  include <direct.h>
#  include <io.h>
#  include <tchar.h>
#  include <windows.h>
#elif defined(__BORLANDC__)
#  include <dir.h>
#  include <dirent.h>
#else
#  include <dirent.h>
#  include <unistd.h>
#endif

#ifdef WIN32
/*

=item C<static int win32_can_execute(PARROT_INTERP, STRING *filename)>

tests if a win32 file is executable

=cut

*/

static int
win32_can_execute(PARROT_INTERP, STRING *filename)
{
    PMC * env = Parrot_pmc_new(interp, enum_class_Env);
    STRING * const pathext_str = Parrot_str_new(interp, "PATHEXT", 7);
    STRING * const pathext_sep = Parrot_str_new(interp, ";", 1);
    STRING * const dot = Parrot_str_new(interp, ".", 1);
    STRING * const pathext = VTABLE_get_string_keyed_str(interp, env, pathext_str);
    PMC * const pathext_pmc = Parrot_str_split(interp, pathext_sep, pathext);
    const INTVAL elems = VTABLE_elements(interp, pathext_pmc);
    INTVAL i;
    STRING * wo_stem = NULL;
    STRING * ext = NULL;
    parrot_split_path_ext(interp, filename, &wo_stem, &ext);
    if (STRING_IS_NULL(ext) || Parrot_str_length(interp, ext) == 0)
        return 0;
    ext = Parrot_str_upcase(interp, ext);
    ext = Parrot_str_concat(interp, dot, ext);

    for (i = 0; i < elems; i++) {
        STRING * const test_ext = VTABLE_get_string_keyed_int(interp, pathext_pmc, i);
        if (Parrot_str_equal(interp, ext, test_ext))
            return 1;
    }
    return 0;
}
#endif

/* XXX Check if we need to deallocate strerror strings */
/* XXX apparently, strerror_r is thread-safe and should be used instead.*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */

static PMC *OS_PMC;
#line 106 "./src/dynpmc/os.c"
static  void  * Parrot_OS_get_pointer(PARROT_INTERP, PMC *_self);
static  void  Parrot_OS_set_pointer(PARROT_INTERP, PMC *_self, void *ptr);
static  void Parrot_OS_nci_cwd(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_chdir(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_rm(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_mkdir(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_stat(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_lstat(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_symlink(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_link(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_umask(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_chroot(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_readdir(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_rename(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_chmod(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_get_user_id(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_can_execute(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_can_read(PARROT_INTERP, PMC *_self);
static  void Parrot_OS_nci_can_write(PARROT_INTERP, PMC *_self);
PARROT_DYNEXT_EXPORT void    Parrot_OS_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_OS_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_OS_get_vtable(PARROT_INTERP);
static  void  *
Parrot_OS_get_pointer(PARROT_INTERP, PMC *_self)
{
#line 100 "./src/dynpmc/os.pmc"

    return OS_PMC;
#line 135 "./src/dynpmc/os.c"
}
static  void 
Parrot_OS_set_pointer(PARROT_INTERP, PMC *_self, void *ptr)
{
#line 104 "./src/dynpmc/os.pmc"

    OS_PMC = (PMC *)ptr;
#line 143 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_cwd(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 154 "./src/dynpmc/os.pmc"
PMC* _self;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 119 "./src/dynpmc/os.pmc"

    char *cwd;
#ifdef _MSC_VER
    cwd = _getcwd(NULL, 0);
    /* capitalize the drive letter */
    cwd[0] = (char)toupper((unsigned char)cwd[0]);
#else
#  ifdef PATH_MAX
    cwd = getcwd(NULL, PATH_MAX+1);
#  else
    cwd = getcwd(NULL, 0);
#  endif
#endif
    if (cwd) {
        STRING * const scwd = Parrot_str_new(interp, cwd, strlen(cwd));
        free(cwd);
        #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *scwd */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)scwd);
    return;
    /*END RETURN STRING *scwd */
    }
#line 135 "./src/dynpmc/os.pmc"

    }
    else {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 201 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_chdir(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 212 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &path);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 154 "./src/dynpmc/os.pmc"

    int error;
    char * const cpath = Parrot_str_to_cstring(interp, path);
#ifdef _MSC_VER
    error = _chdir(cpath);
#else
    error = chdir(cpath);
#endif
    Parrot_str_free_cstring(cpath);
    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 241 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_rm(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 252 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &path);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 181 "./src/dynpmc/os.pmc"

    struct stat info;
    char * const cpath = Parrot_str_to_cstring(interp, path);
    int          error = stat(cpath, &info);

    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_str_free_cstring(cpath);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }

    if (S_ISDIR(info.st_mode)) {
#ifdef _MSC_VER
        error = _rmdir(cpath);
#else
        error = rmdir(cpath);
#endif
        Parrot_str_free_cstring(cpath);
        if (error) {
            const char * const errmsg = strerror(errno);
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
                errmsg);
        }
    }
    else {
        error = remove(cpath);
        Parrot_str_free_cstring(cpath);
        if (error) {
            const char * const errmsg = strerror(errno);
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
                errmsg);
        }
    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 301 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_mkdir(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 312 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;
INTVAL mode;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSI",
            &_self, &path, &mode);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 227 "./src/dynpmc/os.pmc"

    char * const cpath = Parrot_str_to_cstring(interp, path);
    /* should we validate mode? */
#ifdef WIN32
    const int error = _mkdir(cpath);
#else
    const int error = mkdir(cpath, (mode_t)mode);
#endif
    Parrot_str_free_cstring(cpath);
    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 342 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_stat(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 353 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &path);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 272 "./src/dynpmc/os.pmc"

    struct stat   info;
    char  * const cpath = Parrot_str_to_cstring(interp, path);
    const int     error = stat(cpath, &info);

    Parrot_str_free_cstring(cpath);

    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
    else {
        PMC * const array = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
        VTABLE_set_integer_native(interp, array, 13);

        VTABLE_set_integer_keyed_int(interp, array,  0,
                (INTVAL)info.st_dev);
        VTABLE_set_integer_keyed_int(interp, array,  1,
                (INTVAL)info.st_ino);
        VTABLE_set_integer_keyed_int(interp, array,  2,
                (INTVAL)info.st_mode);
        VTABLE_set_integer_keyed_int(interp, array,  3,
                (INTVAL)info.st_nlink);
        VTABLE_set_integer_keyed_int(interp, array,  4,
                (INTVAL)info.st_uid);
        VTABLE_set_integer_keyed_int(interp, array,  5,
                (INTVAL)info.st_gid);
        VTABLE_set_integer_keyed_int(interp, array,  6,
                (INTVAL)info.st_rdev);
        VTABLE_set_integer_keyed_int(interp, array,  7,
                (INTVAL)info.st_size);
        VTABLE_set_integer_keyed_int(interp, array,  8,
                (INTVAL)info.st_atime);
        VTABLE_set_integer_keyed_int(interp, array,  9,
                (INTVAL)info.st_mtime);
        VTABLE_set_integer_keyed_int(interp, array, 10,
                (INTVAL)info.st_ctime);
#ifndef WIN32
        VTABLE_set_integer_keyed_int(interp, array, 11,
                (INTVAL)info.st_blksize);
        VTABLE_set_integer_keyed_int(interp, array, 12,
                (INTVAL)info.st_blocks);
#endif
        #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *array */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)array);
    return;
    /*END RETURN PMC *array */
    }
#line 316 "./src/dynpmc/os.pmc"

    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 424 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_lstat(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 435 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &path);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 346 "./src/dynpmc/os.pmc"

    struct stat info;

    char * const cpath = Parrot_str_to_cstring(interp, path);
#ifdef WIN32
    const int error = stat(cpath, &info);
#else
    const int error = lstat(cpath, &info);
#endif
    Parrot_str_free_cstring(cpath);

    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
    else {
        PMC * const array = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
        VTABLE_set_integer_native(interp, array, 13);

        VTABLE_set_integer_keyed_int(interp, array,  0,
                (INTVAL)info.st_dev);
        VTABLE_set_integer_keyed_int(interp, array,  1,
                (INTVAL)info.st_ino);
        VTABLE_set_integer_keyed_int(interp, array,  2,
                (INTVAL)info.st_mode);
        VTABLE_set_integer_keyed_int(interp, array,  3,
                (INTVAL)info.st_nlink);
        VTABLE_set_integer_keyed_int(interp, array,  4,
                (INTVAL)info.st_uid);
        VTABLE_set_integer_keyed_int(interp, array,  5,
                (INTVAL)info.st_gid);
        VTABLE_set_integer_keyed_int(interp, array,  6,
                (INTVAL)info.st_rdev);
        VTABLE_set_integer_keyed_int(interp, array,  7,
                (INTVAL)info.st_size);
        VTABLE_set_integer_keyed_int(interp, array,  8,
                (INTVAL)info.st_atime);
        VTABLE_set_integer_keyed_int(interp, array,  9,
                (INTVAL)info.st_mtime);
        VTABLE_set_integer_keyed_int(interp, array, 10,
                (INTVAL)info.st_ctime);
#ifndef WIN32
        VTABLE_set_integer_keyed_int(interp, array, 11,
                (INTVAL)info.st_blksize);
        VTABLE_set_integer_keyed_int(interp, array, 12,
                (INTVAL)info.st_blocks);
#endif
        #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *array */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)array);
    return;
    /*END RETURN PMC *array */
    }
#line 394 "./src/dynpmc/os.pmc"

    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 510 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_symlink(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 521 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* from;
STRING* to;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSS",
            &_self, &from, &to);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 408 "./src/dynpmc/os.pmc"

#ifndef WIN32
    char * const cfrom = Parrot_str_to_cstring(interp, from);
    char * const cto   = Parrot_str_to_cstring(interp, to);
    const int error    = symlink(cfrom, cto);

    Parrot_str_free_cstring(cfrom);
    Parrot_str_free_cstring(cto);

    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
#else
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "Win32 does not support symlinks!");
#endif
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 555 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_link(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 566 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* from;
STRING* to;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSS",
            &_self, &from, &to);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 438 "./src/dynpmc/os.pmc"

#ifndef WIN32
    char * const cfrom = Parrot_str_to_cstring(interp, from);
    char * const cto   = Parrot_str_to_cstring(interp, to);
    const int    error = link(cfrom, cto);

    Parrot_str_free_cstring(cfrom);
    Parrot_str_free_cstring(cto);

    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            "link() failed for OS PMC: %s\n", errmsg);
    }
#else
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
            "Win32 is not POSIX. Need win32 developer!");
#endif
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 600 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_umask(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 611 "./src/dynpmc/os.pmc"
PMC* _self;
INTVAL mask;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &mask);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 469 "./src/dynpmc/os.pmc"

#ifndef _MSC_VER
    const INTVAL old = umask((mode_t)mask);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL old */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)old);
    return;
    /*END RETURN INTVAL old */
    }
#line 472 "./src/dynpmc/os.pmc"

#else
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_UNIMPLEMENTED,
        "Win32 is not POSIX. Need Win32 developer!");
#endif
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 645 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_chroot(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 656 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &path);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 494 "./src/dynpmc/os.pmc"

#ifndef WIN32
    char * const cpath = Parrot_str_to_cstring(interp, path);
    const int    error = chroot(cpath);

    Parrot_str_free_cstring(cpath);

    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
#else
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
            "Win32 is not POSIX. Need Win32 developer!");
#endif
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 687 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_readdir(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 698 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &path);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 522 "./src/dynpmc/os.pmc"

    PMC   * array = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
#ifndef _MSC_VER
    char  * const cpath = Parrot_str_to_cstring(interp, path);
    DIR   * const   dir = opendir(cpath);
    struct dirent *dirent;

    Parrot_str_free_cstring(cpath);

    if (!dir) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }

    while ((dirent = readdir(dir)) != NULL) {
        const char *const name = dirent->d_name;
        VTABLE_push_string(interp, array, Parrot_str_from_platform_cstring(interp, name));
    }

    closedir(dir);
#else
    WIN32_FIND_DATA file_find_data;
    char * cpath;
    HANDLE hFind = INVALID_HANDLE_VALUE;

    /* Add \* to the directory name and start search. */
    INTVAL last_char = STRING_ord(interp, path, -1);
    int trailing_slash = last_char == '\\' || last_char == '/';
    cpath = Parrot_str_to_cstring(interp, Parrot_str_concat(interp,
            path, string_from_literal(interp, trailing_slash ? "*" : "\\*"), 0));
    hFind = FindFirstFile(cpath, &file_find_data);
    Parrot_str_free_cstring(cpath);
    if (hFind == INVALID_HANDLE_VALUE)
    {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            "Unable to readdir");
    }

    /* Loop over all directories and add to result array. */
    do
    {
        VTABLE_push_string(interp, array, Parrot_str_new(interp,
                file_find_data.cFileName, 0));
    }
    while (FindNextFile(hFind, &file_find_data) != 0);
    if (GetLastError() != ERROR_NO_MORE_FILES)
    {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            "Error during readdir");
    }
    FindClose(hFind);
#endif
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *array */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)array);
    return;
    /*END RETURN PMC *array */
    }
#line 575 "./src/dynpmc/os.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 777 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_rename(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 788 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* oldpath;
STRING* newpath;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSS",
            &_self, &oldpath, &newpath);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 586 "./src/dynpmc/os.pmc"

    char * const coldpath = Parrot_str_to_cstring(interp, oldpath);
    char * const cnewpath = Parrot_str_to_cstring(interp, newpath);
    const int    ret      = rename(coldpath, cnewpath);

    Parrot_str_free_cstring(coldpath);
    Parrot_str_free_cstring(cnewpath);

    if (ret < 0) {
        const char * const errmsg = strerror(errno) ;
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            "%s", errmsg);
    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 817 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_chmod(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 828 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* path;
INTVAL mode;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSI",
            &_self, &path, &mode);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 609 "./src/dynpmc/os.pmc"

    char * const cpath = Parrot_str_to_cstring(interp, path);

#ifndef WIN32
    const int    error = chmod(cpath, mode);
#else
    const int    error = _chmod(cpath, mode);
#endif

    Parrot_str_free_cstring(cpath);

    if (error) {
        const char * const errmsg = strerror(errno);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_EXTERNAL_ERROR,
            errmsg);
    }
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 860 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_get_user_id(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 871 "./src/dynpmc/os.pmc"
PMC* _self;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 637 "./src/dynpmc/os.pmc"

    const UINTVAL uid = Parrot_get_user_id();
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL uid */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)uid);
    return;
    /*END RETURN INTVAL uid */
    }
#line 639 "./src/dynpmc/os.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 898 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_can_execute(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 909 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* filename;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &filename);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 650 "./src/dynpmc/os.pmc"

    INTVAL can = 0;
#ifndef WIN32
    char * const file = Parrot_str_to_cstring(interp, filename);
    can = access(file, X_OK) + 1;
    Parrot_str_free_cstring(file);
#else
    can = win32_can_execute(interp, filename);
#endif
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL can */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)can);
    return;
    /*END RETURN INTVAL can */
    }
#line 659 "./src/dynpmc/os.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 944 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_can_read(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 955 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* filename;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &filename);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 662 "./src/dynpmc/os.pmc"

    char * const file = Parrot_str_to_cstring(interp, filename);
    INTVAL can = 0;
#ifndef WIN32
    can = access(file, R_OK) + 1;
#else
    can = 1;
#endif
    Parrot_str_free_cstring(file);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL can */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)can);
    return;
    /*END RETURN INTVAL can */
    }
#line 671 "./src/dynpmc/os.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 990 "./src/dynpmc/os.c"
}
static  void
Parrot_OS_nci_can_write(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1001 "./src/dynpmc/os.pmc"
PMC* _self;
STRING* filename;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &filename);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 674 "./src/dynpmc/os.pmc"

    char * const file = Parrot_str_to_cstring(interp, filename);
    INTVAL can = 0;
#ifndef WIN32
    can = access(file, W_OK) + 1;
#else
    /* TODO: Win32 */
#endif
    Parrot_str_free_cstring(file);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL can */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)can);
    return;
    /*END RETURN INTVAL can */
    }
#line 683 "./src/dynpmc/os.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1036 "./src/dynpmc/os.c"
}
#include "pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_OS_update_vtable(VTABLE *vt) {
    vt->get_pointer = Parrot_OS_get_pointer;
    vt->set_pointer = Parrot_OS_set_pointer;

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_OS_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_pointer = Parrot_OS_get_pointer;

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OS_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_OS_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OS_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_OS_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_OS_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "OS", 2,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_OS_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "OS")), PMCNULL);
    return isa;
}

static void thispmc_class_init(PARROT_INTERP, int entry)
{
    
        OS_PMC = NULL;

}
void
Parrot_OS_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_OS_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_PMC_IS_SINGLETON;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = Parrot_str_new_init(interp, "OS", 2,
                                       Parrot_ascii_encoding_ptr, PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_concat(interp, vt->provides_str,
            Parrot_str_new_init(interp, "scalar", 6, Parrot_ascii_encoding_ptr,
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = Parrot_OS_get_isa(interp, NULL);
    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_OS_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "cwd");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_cwd),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "chdir");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_chdir),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "rm");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_rm),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "mkdir");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_mkdir),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "stat");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_stat),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "lstat");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_lstat),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "symlink");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_symlink),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "link");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_link),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "umask");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_umask),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "chroot");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_chroot),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "readdir");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_readdir),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "rename");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_rename),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "chmod");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_chmod),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "get_user_id");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_get_user_id),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "can_execute");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_can_execute),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "can_read");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_can_read),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "can_write");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_OS_nci_can_write),
                method_name, signature);
        }

        /* class_init */
        thispmc_class_init(interp, entry);


        {
        }
    } /* pass */
} /* Parrot_OS_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_os_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_os_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeOS;
    int pass;

    /* create a library PMC */
    pmc = Parrot_pmc_new_constant(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "OS");
    typeOS = Parrot_pmc_register_new_type(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_OS_class_init(interp, typeOS, pass);
    }
    return pmc;
}

#line 685 "./src/dynpmc/os.pmc"


/*

=back

=head1 SEE ALS0

   chdir(2), getcwd(3), unlink(2), mkdir(2), stat(2), lstat(2),
   symlink(2), link(2), umask(2), chroot(2)

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
