/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bytebuffer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bytebuffer.h"
#include "pmc_default.h"
#include "bytebuffer.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/bytebuffer.pmc"
/*
Copyright (C) 2010, Parrot Foundation.

=head1 NAME

src/pmc/bytebuffer.pmc - A byte buffer

=head1 DESCRIPTION

C<ByteBuffer> provides a resizable byte buffer with random access to
individual bytes and conversions from and to parrot strings.

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_CANNOT_RETURN_NULL
static STRING * build_string(PARROT_INTERP,
    ARGIN_NULLOK(const unsigned char *content),
    INTVAL size,
    ARGIN_NULLOK(const STR_VTABLE *encoding))
        __attribute__nonnull__(1);

static INTVAL grow_to(INTVAL position);
#define ASSERT_ARGS_build_string __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_grow_to __attribute__unused__ int _ASSERT_ARGS_CHECK = (0)
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */
#line 57 "./src/pmc/bytebuffer.c"
static  void  Parrot_ByteBuffer_destroy(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_ByteBuffer_elements(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_ByteBuffer_get_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL position);
static  PMC  * Parrot_ByteBuffer_get_iter(PARROT_INTERP, PMC *_self);
static  void  Parrot_ByteBuffer_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_ByteBuffer_init_int(PARROT_INTERP, PMC *_self, INTVAL initial_size);
static  void  Parrot_ByteBuffer_mark(PARROT_INTERP, PMC *_self);
static  void  Parrot_ByteBuffer_push_integer(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_ByteBuffer_set_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL position, INTVAL value);
static  void  Parrot_ByteBuffer_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL set_size);
static  void  Parrot_ByteBuffer_set_string_native(PARROT_INTERP, PMC *_self, STRING *new_string);
static  void Parrot_ByteBuffer_nci_get_string(PARROT_INTERP, PMC *_self);
static  void Parrot_ByteBuffer_nci_get_string_as(PARROT_INTERP, PMC *_self);
static  void Parrot_ByteBuffer_nci_get_chars(PARROT_INTERP, PMC *_self);
void    Parrot_ByteBuffer_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ByteBuffer_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ByteBuffer_get_vtable(PARROT_INTERP);
void    Parrot_ByteBuffer_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ByteBuffer_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ByteBuffer_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_ByteBuffer_destroy(PARROT_INTERP, PMC *_self)
{
#line 90 "./src/pmc/bytebuffer.pmc"

    INTVAL allocated_size;
    GETATTR_ByteBuffer_allocated_size(interp, _self, allocated_size);
    if (allocated_size) {
        unsigned char *content;
        GETATTR_ByteBuffer_content(interp, _self, content);
        Parrot_gc_free_memory_chunk(interp, content);
    }
#line 90 "./src/pmc/bytebuffer.c"
}
static  INTVAL 
Parrot_ByteBuffer_elements(PARROT_INTERP, PMC *_self)
{
#line 110 "./src/pmc/bytebuffer.pmc"

    INTVAL size;
    GETATTR_ByteBuffer_size(interp, _self, size);
    return size;
#line 100 "./src/pmc/bytebuffer.c"
}
static  INTVAL 
Parrot_ByteBuffer_get_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL position)
{
#line 207 "./src/pmc/bytebuffer.pmc"

    INTVAL size;
    unsigned char *content;
    GETATTR_ByteBuffer_size(interp, _self, size);
    GETATTR_ByteBuffer_content(interp, _self, content);
    return (position >= 0 && position < size) ? content[position] : (INTVAL) 0;
#line 112 "./src/pmc/bytebuffer.c"
}
static  PMC  *
Parrot_ByteBuffer_get_iter(PARROT_INTERP, PMC *_self)
{
#line 296 "./src/pmc/bytebuffer.pmc"

    return Parrot_pmc_new_init(interp, enum_class_ArrayIterator, _self);
#line 120 "./src/pmc/bytebuffer.c"
}
static  void 
Parrot_ByteBuffer_init(PARROT_INTERP, PMC *_self)
{
#line 67 "./src/pmc/bytebuffer.pmc"

    PObj_custom_mark_destroy_SETALL(_self);
#line 128 "./src/pmc/bytebuffer.c"
}
static  void 
Parrot_ByteBuffer_init_int(PARROT_INTERP, PMC *_self, INTVAL initial_size)
{
#line 71 "./src/pmc/bytebuffer.pmc"

    unsigned char *content;
    if (initial_size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            _("ByteBuffer: Cannot set buffer size to a negative number (%d)"), initial_size);
    Parrot_ByteBuffer_init(interp, _self);
    SETATTR_ByteBuffer_size(interp, _self, initial_size);
    SETATTR_ByteBuffer_allocated_size(interp, _self, initial_size);
    content = (unsigned char *)Parrot_gc_allocate_memory_chunk(interp, initial_size);
    SETATTR_ByteBuffer_content(interp, _self, content);
#line 144 "./src/pmc/bytebuffer.c"
}
static  void 
Parrot_ByteBuffer_mark(PARROT_INTERP, PMC *_self)
{
#line 83 "./src/pmc/bytebuffer.pmc"

    STRING * source;
    GETATTR_ByteBuffer_source(interp, _self, source);
    if (!STRING_IS_NULL(source))
        Parrot_gc_mark_STRING_alive(interp, source);
#line 155 "./src/pmc/bytebuffer.c"
}
static  void 
Parrot_ByteBuffer_push_integer(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 279 "./src/pmc/bytebuffer.pmc"

    INTVAL size;

    GETATTR_ByteBuffer_size(interp, _self, size);
    VTABLE_set_integer_keyed_int(interp, _self, size, value);
#line 166 "./src/pmc/bytebuffer.c"
}
static  void 
Parrot_ByteBuffer_set_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL position, INTVAL value)
{
#line 226 "./src/pmc/bytebuffer.pmc"

    unsigned char *content;
    INTVAL size, allocated_size;
    if (position < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Negative position not allowed");

    GETATTR_ByteBuffer_allocated_size(interp, _self, allocated_size);
    if (position >= allocated_size) {
        INTVAL newsize = grow_to(position);
        if (allocated_size == 0) {
            INTVAL copysize = newsize;
            STRING * source;
            content = (unsigned char *)Parrot_gc_allocate_memory_chunk(interp, newsize);
            GETATTR_ByteBuffer_source(interp, _self, source);
            if (!STRING_IS_NULL(source)) {
                INTVAL srclen = Parrot_str_byte_length(interp, source);
                if (srclen < copysize)
                    copysize = srclen;
                memcpy(content, source->strstart, copysize);
                SETATTR_ByteBuffer_source(interp, _self, STRINGNULL);
            }
        }
        else {
            GETATTR_ByteBuffer_content(interp, _self, content);
            content = (unsigned char *)
                Parrot_gc_reallocate_memory_chunk(interp, content, newsize);
        }

        SETATTR_ByteBuffer_content(interp, _self, content);
        SETATTR_ByteBuffer_allocated_size(interp, _self, newsize);
    }
    else
        GETATTR_ByteBuffer_content(interp, _self, content);

    GETATTR_ByteBuffer_size(interp, _self, size);
    if (position >= size) {
        size = position + 1;
        SETATTR_ByteBuffer_size(interp, _self, size);
    }
    content[position] = value;
#line 213 "./src/pmc/bytebuffer.c"
}
static  void 
Parrot_ByteBuffer_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL set_size)
{
#line 126 "./src/pmc/bytebuffer.pmc"

    INTVAL size,  allocated_size;
    unsigned char *content;
    if (set_size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Negative size in ByteBuffer");

    GETATTR_ByteBuffer_allocated_size(interp, _self, allocated_size);
    if (set_size == 0) {
        if (allocated_size == 0)
            SETATTR_ByteBuffer_source(interp, _self, STRINGNULL);
        else {
            GETATTR_ByteBuffer_content(interp, _self, content);
            Parrot_gc_free_memory_chunk(interp, content);
        }
        SETATTR_ByteBuffer_allocated_size(interp, _self, 0);
        SETATTR_ByteBuffer_size(interp, _self, 0);
        SETATTR_ByteBuffer_content(interp, _self, NULL);
    }
    else {
        GETATTR_ByteBuffer_size(interp, _self, size);
        /* If reducing size, just change the size value */
        if (set_size > size) {
            INTVAL copysize = set_size < size ? set_size : size;
            if (allocated_size == 0) {
                content = (unsigned char *)Parrot_gc_allocate_memory_chunk(interp, set_size);
                if (size > 0) {
                    STRING * source;
                    GETATTR_ByteBuffer_source(interp, _self, source);
                    memcpy(content, source->strstart, copysize);
                }
                SETATTR_ByteBuffer_source(interp, _self, STRINGNULL);
            }
            else {
                GETATTR_ByteBuffer_content(interp, _self, content);
                content = (unsigned char *)
                    Parrot_gc_reallocate_memory_chunk(interp, content, set_size);
            }
            if (copysize < set_size)
                memset(content + copysize, '\0', set_size - copysize);
            SETATTR_ByteBuffer_allocated_size(interp, _self, set_size);
            SETATTR_ByteBuffer_content(interp, _self, content);
        }
        SETATTR_ByteBuffer_size(interp, _self, set_size);
    }
#line 264 "./src/pmc/bytebuffer.c"
}
static  void 
Parrot_ByteBuffer_set_string_native(PARROT_INTERP, PMC *_self, STRING *new_string)
{
#line 183 "./src/pmc/bytebuffer.pmc"

    INTVAL allocated_size;
    GETATTR_ByteBuffer_allocated_size(interp, _self, allocated_size);
    if (allocated_size) {
        unsigned char *content;
        GETATTR_ByteBuffer_content(interp, _self, content);
        Parrot_gc_free_memory_chunk(interp, content);
        SETATTR_ByteBuffer_allocated_size(interp, _self, 0);
    }
    SETATTR_ByteBuffer_source(interp, _self, new_string);
    SETATTR_ByteBuffer_size(interp, _self, Parrot_str_byte_length(interp, new_string));
    SETATTR_ByteBuffer_content(interp, _self, (unsigned char *)new_string->strstart);
#line 282 "./src/pmc/bytebuffer.c"
}
static  void
Parrot_ByteBuffer_nci_get_string(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 293 "./src/pmc/bytebuffer.pmc"
PMC* _self;
STRING* encodingname;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &encodingname);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 316 "./src/pmc/bytebuffer.pmc"

    STRING *result;
    unsigned char *content;
    INTVAL size;
    const STR_VTABLE *encoding = Parrot_find_encoding_by_string(interp, encodingname);
    GETATTR_ByteBuffer_content(interp, _self, content);
    GETATTR_ByteBuffer_size(interp, _self, size);
    result = build_string(interp, content, size, encoding);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 324 "./src/pmc/bytebuffer.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 327 "./src/pmc/bytebuffer.c"
}
static  void
Parrot_ByteBuffer_nci_get_string_as(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 338 "./src/pmc/bytebuffer.pmc"
PMC* _self;
STRING* as;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSo",
            &_self, &as);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 338 "./src/pmc/bytebuffer.pmc"

    STRING *result;
    unsigned char *content;
    INTVAL size;
    const STR_VTABLE *encoding = STRING_IS_NULL(as) ?
            Parrot_default_encoding_ptr : as->encoding;
    GETATTR_ByteBuffer_content(interp, _self, content);
    GETATTR_ByteBuffer_size(interp, _self, size);
    result = build_string(interp, content, size, encoding);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 347 "./src/pmc/bytebuffer.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 373 "./src/pmc/bytebuffer.c"
}
static  void
Parrot_ByteBuffer_nci_get_chars(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 384 "./src/pmc/bytebuffer.pmc"
PMC* _self;
INTVAL pos;
INTVAL length;
STRING* encodingname;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIIS",
            &_self, &pos, &length, &encodingname);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 362 "./src/pmc/bytebuffer.pmc"

    const STR_VTABLE *encoding = Parrot_find_encoding_by_string(interp, encodingname);
    STRING           *result;
    unsigned char    *content;
    INTVAL            size;

    GETATTR_ByteBuffer_content(interp, _self, content);
    GETATTR_ByteBuffer_size(interp, _self, size);

    if (pos < 0 || pos > size)
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_OUT_OF_BOUNDS,
                "get_chars: index out of bounds");

    result = Parrot_str_extract_chars(interp, (char *)content + pos,
                size - pos, length, encoding);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 378 "./src/pmc/bytebuffer.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 428 "./src/pmc/bytebuffer.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ByteBuffer_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_ByteBuffer_destroy;
    vt->elements = Parrot_ByteBuffer_elements;
    vt->get_integer_keyed_int = Parrot_ByteBuffer_get_integer_keyed_int;
    vt->get_iter = Parrot_ByteBuffer_get_iter;
    vt->init = Parrot_ByteBuffer_init;
    vt->init_int = Parrot_ByteBuffer_init_int;
    vt->mark = Parrot_ByteBuffer_mark;
    vt->push_integer = Parrot_ByteBuffer_push_integer;
    vt->set_integer_keyed_int = Parrot_ByteBuffer_set_integer_keyed_int;
    vt->set_integer_native = Parrot_ByteBuffer_set_integer_native;
    vt->set_string_native = Parrot_ByteBuffer_set_string_native;
    vt->attr_size = sizeof(Parrot_ByteBuffer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ByteBuffer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_ByteBuffer_destroy;
    vt->elements = Parrot_ByteBuffer_elements;
    vt->get_integer_keyed_int = Parrot_ByteBuffer_get_integer_keyed_int;
    vt->get_iter = Parrot_ByteBuffer_get_iter;
    vt->init = Parrot_ByteBuffer_init;
    vt->init_int = Parrot_ByteBuffer_init_int;
    vt->mark = Parrot_ByteBuffer_mark;
    vt->attr_size = sizeof(Parrot_ByteBuffer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ByteBuffer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_ByteBuffer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ByteBuffer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_ByteBuffer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ByteBuffer_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "ByteBuffer", 10,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ByteBuffer_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ByteBuffer")), PMCNULL);
    return isa;
}

void
Parrot_ByteBuffer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iallocated_size Isize Ssource :content ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ByteBuffer_get_vtable(interp);
        vt->base_type      = enum_class_ByteBuffer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ByteBuffer");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_ByteBuffer_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ByteBuffer_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ByteBuffer;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ByteBuffer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "get_string");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ByteBuffer_nci_get_string),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "get_string_as");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ByteBuffer_nci_get_string_as),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "get_chars");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ByteBuffer_nci_get_chars),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_ByteBuffer_class_init */
#line 380 "./src/pmc/bytebuffer.pmc"
 /* pmclass end */

/*

=back

=head2 Auxiliar functions

=over 4

=item C<static INTVAL grow_to(INTVAL position)>

Calculate new size enough for using position and with some margin to
decrease the number of reallocations.

=item C<static STRING * build_string(PARROT_INTERP, const unsigned char
*content, INTVAL size, const STR_VTABLE *encoding)>

Build a string from the buffer content with the encoding specified.

=cut

*/

static INTVAL
grow_to(INTVAL position)
{
    ASSERT_ARGS(grow_to)

    const UINTVAL blocksize = 2048;
    UINTVAL minsize = position + 1;
    return (INTVAL) (minsize < 64 ? 64 :
           minsize < 256 ? 256 :
           minsize < 1024 ? 1024 :
           ((minsize + blocksize - 1) / blocksize) * blocksize);
}

PARROT_CANNOT_RETURN_NULL
static STRING *
build_string(PARROT_INTERP, ARGIN_NULLOK(const unsigned char *content),
        INTVAL size,
        ARGIN_NULLOK(const STR_VTABLE *encoding))
{
    ASSERT_ARGS(build_string)
    if (encoding == NULL)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_ENCODING,
                "Invalid encoding");
    else {
        STRING * const result = Parrot_str_new_init(interp,
                (const char *)content, size, encoding, 0);
        return result;
    }
}

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
