/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/orderedhash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_orderedhash.h"
#include "pmc_default.h"
#include "orderedhash.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/orderedhash.pmc"
/*
Copyright (C) 2001-2010, Parrot Foundation.

=head1 NAME

src/pmc/orderedhash.pmc - Ordered Hash

=head1 DESCRIPTION

C<OrderedHash> provide the interfaces of C<array> and
C<hash>.

Some limitations:

=over 4

=item *

Keys are always STRING*.

=item *

Values are always PMC*.

=back

To archive ordering for each item we store:

=over 4

=item * C<key>

Original key

=item * C<value>

Original value

=item * C<next>

Pointer to next C<item>

=item * C<prev>

Pointer to previous C<item>

=back

OrderedHash stores next things:

=over 4

=item * C<hash>

Lookup hash for values.

=item * C<first>

Pointer to first inserted value.

=item * C<last>

Pointer to last inserter value.

=back

See F<t/pmc/orderedhash.t> for test cases.

Overall design heavily inspired by C<Tie::StoredOrderHash>.

=head2 Methods

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static PMC* box_integer(PARROT_INTERP, INTVAL val)
        __attribute__nonnull__(1);

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static PMC* box_number(PARROT_INTERP, FLOATVAL val)
        __attribute__nonnull__(1);

static void find_bounds(PARROT_INTERP,
    ARGIN(PMC *pmc_hash),
    ARGMOD(PMC **first),
    ARGMOD(PMC **last))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*first)
        FUNC_MODIFIES(*last);

PARROT_WARN_UNUSED_RESULT
PARROT_CAN_RETURN_NULL
static PMC* get_list_item(PARROT_INTERP, ARGIN(PMC *self), INTVAL idx)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

#define ASSERT_ARGS_box_integer __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_box_number __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_find_bounds __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(pmc_hash) \
    , PARROT_ASSERT_ARG(first) \
    , PARROT_ASSERT_ARG(last))
#define ASSERT_ARGS_get_list_item __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static PMC* get_list_item(PARROT_INTERP, PMC *self, INTVAL idx)>

Get list_item by index

XXX Can this actually return NULL or not?

=cut

*/

PARROT_WARN_UNUSED_RESULT
PARROT_CAN_RETURN_NULL
static PMC*
get_list_item(PARROT_INTERP, ARGIN(PMC *self), INTVAL idx)
{
    ASSERT_ARGS(get_list_item)

    const Parrot_OrderedHash_attributes * const attrs = PARROT_ORDEREDHASH(self);
    const INTVAL n = VTABLE_elements(interp, attrs->hash);
    INTVAL                         pos;
    PMC                           *list_entry = attrs->first;

    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;

    /* Iterate over linked list to get list_item */
    for (pos = 0; pos < idx; ++pos) {
        list_entry = VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_NEXT);
    }
    return list_entry;
}

/*

=item C<static void find_bounds(PARROT_INTERP, PMC *pmc_hash, PMC **first, PMC
**last)>

Find first/last in cloned/thawed OrderedHash

Parameter C<pmc_hash> is Hash, not OrderedHash

=cut

*/

static void
find_bounds(PARROT_INTERP, ARGIN(PMC *pmc_hash), ARGMOD(PMC **first), ARGMOD(PMC **last))
{
    ASSERT_ARGS(find_bounds)

    PMC * const iter = VTABLE_get_iter(interp, pmc_hash);

    while (VTABLE_get_bool(interp, iter)) {
        PMC * const item  = VTABLE_shift_pmc(interp, iter);
        PMC * const entry = VTABLE_get_pmc_keyed(interp, pmc_hash, item);
        /* First entry doesn't have prev */
        PMC *tmp   = VTABLE_get_pmc_keyed_int(interp, entry, ORDERED_HASH_ITEM_PREV);
        if (PMC_IS_NULL(tmp))
            *first = entry;
        /* Last entry doesn't have next */
        tmp   = VTABLE_get_pmc_keyed_int(interp, entry, ORDERED_HASH_ITEM_NEXT);
        if (PMC_IS_NULL(tmp))
            *last = entry;
    }
}

/* Helpers for boxing values */

/*

=item C<static PMC* box_integer(PARROT_INTERP, INTVAL val)>

Helper function to box INTVAL

=cut

*/

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static PMC*
box_integer(PARROT_INTERP, INTVAL val)
{
    ASSERT_ARGS(box_integer)

    PMC * const ret = Parrot_pmc_new(interp, Parrot_hll_get_ctx_HLL_type(interp,
                enum_class_Integer));
    VTABLE_set_integer_native(interp, ret, val);
    return ret;
}

/*

=item C<static PMC* box_number(PARROT_INTERP, FLOATVAL val)>

Helper function to box FLOATVAL

=cut

*/

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static PMC*
box_number(PARROT_INTERP, FLOATVAL val)
{
    ASSERT_ARGS(box_number)

    PMC * const ret = Parrot_pmc_new(interp, Parrot_hll_get_ctx_HLL_type(interp,
                enum_class_Float));
    VTABLE_set_number_native(interp, ret, val);
    return ret;
}
#line 264 "./src/pmc/orderedhash.c"
static  PMC  * Parrot_OrderedHash_clone(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx);
static  void  Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  void  Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx);
static  void  Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  INTVAL  Parrot_OrderedHash_elements(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx);
static  INTVAL  Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  INTVAL  Parrot_OrderedHash_get_integer(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx);
static  PMC  * Parrot_OrderedHash_get_iter(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_OrderedHash_get_number(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  FLOATVAL  Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx);
static  PMC*  Parrot_OrderedHash_get_pmc(PARROT_INTERP, PMC *_self);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  STRING  * Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  STRING  * Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx);
static  void  Parrot_OrderedHash_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_OrderedHash_mark(PARROT_INTERP, PMC *_self);
static  void  Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *_self, STRING *value);
static  void  Parrot_OrderedHash_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value);
static  void  Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, INTVAL value);
static  void  Parrot_OrderedHash_set_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, INTVAL value);
static  void  Parrot_OrderedHash_set_number_keyed(PARROT_INTERP, PMC *_self, PMC *key, FLOATVAL value);
static  void  Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, FLOATVAL value);
static  void  Parrot_OrderedHash_set_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, FLOATVAL value);
static  void  Parrot_OrderedHash_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value);
static  void  Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, PMC *val);
static  void  Parrot_OrderedHash_set_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, PMC *value);
static  void  Parrot_OrderedHash_set_string_keyed(PARROT_INTERP, PMC *_self, PMC *key, STRING *value);
static  void  Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, STRING *value);
static  void  Parrot_OrderedHash_set_string_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, STRING *value);
static  void  Parrot_OrderedHash_thawfinish(PARROT_INTERP, PMC *_self, PMC *info);
static  void  Parrot_OrderedHash_visit(PARROT_INTERP, PMC *_self, PMC *info);
void    Parrot_OrderedHash_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_OrderedHash_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_OrderedHash_get_vtable(PARROT_INTERP);
void    Parrot_OrderedHash_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_OrderedHash_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_OrderedHash_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_OrderedHash_clone(PARROT_INTERP, PMC *_self)
{
#line 794 "./src/pmc/orderedhash.pmc"

    PMC  * const dest   = Parrot_pmc_new(interp, _self->vtable->base_type);
    Parrot_OrderedHash_attributes *clone_attrs =
            PARROT_ORDEREDHASH(dest);

    clone_attrs->hash   = VTABLE_clone(interp, PARROT_ORDEREDHASH(_self)->hash);
    find_bounds(interp, clone_attrs->hash, &clone_attrs->first, &clone_attrs->last);

    return dest;
#line 327 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 694 "./src/pmc/orderedhash.pmc"

    /* We store list_item (which is defined). So fetch original PMC and check it */
    PMC * const item = Parrot_OrderedHash_get_pmc_keyed(interp, _self, key);
    if (PMC_IS_NULL(item))
        return 0;
    return VTABLE_defined(interp, item);
#line 339 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx)
{
#line 702 "./src/pmc/orderedhash.pmc"

    PMC * item;
    /* If item doesn't exists it's undefined */
    if (!Parrot_OrderedHash_exists_keyed_int(interp, _self, idx))
        return 0;

    /* Null is undefined */
    item = Parrot_OrderedHash_get_pmc_keyed_int(interp, _self, idx);
    if (PMC_IS_NULL(item))
        return 0;

    return VTABLE_defined(interp, item);
#line 357 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 730 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes *attrs =
            PARROT_ORDEREDHASH(_self);
    PMC *list_entry, *prev, *next;
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        const INTVAL intval = VTABLE_get_integer(interp, key);
        PMC * const next    = VTABLE_shift_pmc(interp, key);

        if (next)
            VTABLE_delete_keyed(interp, Parrot_OrderedHash_get_pmc_keyed_int(interp, _self, intval), next);
        else
            Parrot_OrderedHash_delete_keyed_int(interp, _self, intval);

        return;
    }

    list_entry = VTABLE_get_pmc_keyed(interp, attrs->hash, key);
    if (PMC_IS_NULL(list_entry))
        return;

    /* Unlink entry */
    next = VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_NEXT);
    prev = VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_PREV);

    if (attrs->first == list_entry)
        attrs->first = next;

    if (attrs->last == list_entry)
        attrs->last = prev;

    /* C<prev> and C<next> are list entries (FPA) */
    if (!PMC_IS_NULL(prev))
        VTABLE_set_pmc_keyed_int(interp, prev, ORDERED_HASH_ITEM_NEXT, next);
    if (!PMC_IS_NULL(next))
        VTABLE_set_pmc_keyed_int(interp, next, ORDERED_HASH_ITEM_PREV, prev);

    /* And finally delete it */
    VTABLE_delete_keyed(interp, PARROT_ORDEREDHASH(_self)->hash, key);
#line 401 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx)
{
#line 774 "./src/pmc/orderedhash.pmc"

    if (Parrot_OrderedHash_exists_keyed_int(interp, _self, idx)) {
        PMC * const list_entry = get_list_item(interp, _self, idx);
        Parrot_OrderedHash_delete_keyed(interp, _self, VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_KEY));
    }
    return;
#line 413 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 770 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_delete_keyed(interp, _self, Parrot_pmc_box_string(interp, key));
#line 421 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_elements(PARROT_INTERP, PMC *_self)
{
#line 326 "./src/pmc/orderedhash.pmc"

    return VTABLE_elements(interp, PARROT_ORDEREDHASH(_self)->hash);
#line 429 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 665 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        /* Don't fetch item prematurely. It's costy */
        const INTVAL intval = VTABLE_get_integer(interp, key);
        PMC * const next    = VTABLE_shift_pmc(interp, key);

        if (!next)
            return Parrot_OrderedHash_exists_keyed_int(interp, _self, intval);

        return VTABLE_exists_keyed(interp, Parrot_OrderedHash_get_pmc_keyed_int(interp, _self, intval), next);
    }

    return VTABLE_exists_keyed_str(interp, _self, VTABLE_get_string(interp, key));
#line 448 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx)
{
#line 661 "./src/pmc/orderedhash.pmc"

    return (idx >= 0) && (idx < Parrot_OrderedHash_elements(interp, _self));
#line 456 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 680 "./src/pmc/orderedhash.pmc"

    return VTABLE_exists_keyed_str(interp, PARROT_ORDEREDHASH(_self)->hash, key);
#line 464 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer(PARROT_INTERP, PMC *_self)
{
#line 318 "./src/pmc/orderedhash.pmc"

    return Parrot_OrderedHash_elements(interp, _self);
#line 472 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 528 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed(interp, _self, key);
    return VTABLE_get_integer(interp, item);
#line 481 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx)
{
#line 523 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed_int(interp, _self, idx);
    return VTABLE_get_integer(interp, item);
#line 490 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_iter(PARROT_INTERP, PMC *_self)
{
#line 300 "./src/pmc/orderedhash.pmc"

    return Parrot_pmc_new_init(interp, enum_class_OrderedHashIterator, _self);
#line 498 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number(PARROT_INTERP, PMC *_self)
{
#line 322 "./src/pmc/orderedhash.pmc"

    return VTABLE_get_integer(interp, _self);
#line 506 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 552 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed(interp, _self, key);
    return VTABLE_get_number(interp, item);
#line 515 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx)
{
#line 547 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed_int(interp, _self, idx);
    return VTABLE_get_number(interp, item);
#line 524 "./src/pmc/orderedhash.c"
}
static  PMC* 
Parrot_OrderedHash_get_pmc(PARROT_INTERP, PMC *_self)
{
#line 843 "./src/pmc/orderedhash.pmc"

    PMC *hash;
    GETATTR_OrderedHash_hash(interp, _self, hash);
    return hash;
#line 534 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 466 "./src/pmc/orderedhash.pmc"

    PMC *item;

    /* Access by integer index */
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG)
        return VTABLE_get_pmc_keyed_int(interp, _self, VTABLE_get_integer(interp, key));

    item = VTABLE_get_pmc_keyed(interp, PARROT_ORDEREDHASH(_self)->hash, key);
    if (PMC_IS_NULL(item))
        return PMCNULL;
    return VTABLE_get_pmc_keyed_int(interp, item, ORDERED_HASH_ITEM_VALUE);
#line 551 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx)
{
#line 457 "./src/pmc/orderedhash.pmc"

    PMC * const list_entry = get_list_item(interp, _self, idx);

    if (PMC_IS_NULL(list_entry))
        return PMCNULL;

    return VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE);
#line 564 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 479 "./src/pmc/orderedhash.pmc"

    PMC *item = VTABLE_get_pmc_keyed_str(interp,
        PARROT_ORDEREDHASH(_self)->hash, key);

    if (PMC_IS_NULL(item))
        return PMCNULL;

    return VTABLE_get_pmc_keyed_int(interp, item, ORDERED_HASH_ITEM_VALUE);
#line 578 "./src/pmc/orderedhash.c"
}
static  STRING  *
Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 505 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed(interp, _self, key);
    return VTABLE_get_string(interp, item);
#line 587 "./src/pmc/orderedhash.c"
}
static  STRING  *
Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx)
{
#line 500 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed_int(interp, _self, idx);
    return VTABLE_get_string(interp, item);
#line 596 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_init(PARROT_INTERP, PMC *_self)
{
#line 259 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes * const attrs =
            (Parrot_OrderedHash_attributes*) PMC_data(_self);

    attrs->hash     = Parrot_pmc_new(interp, enum_class_Hash);
    attrs->first    = PMCNULL;
    attrs->last     = PMCNULL;

    PObj_custom_mark_destroy_SETALL(_self);
#line 611 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_mark(PARROT_INTERP, PMC *_self)
{
#line 280 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes * const attrs =
            PARROT_ORDEREDHASH(_self);

    if (attrs->hash)
        Parrot_gc_mark_PMC_alive(interp, attrs->hash);

    /* Don't mark C<first> and C<last>. They are in lookup hash anyway */
#line 625 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 634 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, _self);
    VTABLE_set_number_keyed_int(interp, _self, n, value);
#line 634 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 639 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, _self);
    VTABLE_set_integer_keyed_int(interp, _self, n, value);
#line 643 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 629 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, _self);
    VTABLE_set_pmc_keyed_int(interp, _self, n, value);
#line 652 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *_self, STRING *value)
{
#line 644 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, _self);
    VTABLE_set_string_keyed_int(interp, _self, n, value);
#line 661 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value)
{
#line 388 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_integer(interp, value);
    VTABLE_set_pmc_keyed(interp, _self, key, v);
#line 670 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, INTVAL value)
{
#line 595 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_new(interp, Parrot_hll_get_ctx_HLL_type(interp,
                enum_class_Integer));
    VTABLE_set_integer_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, _self, idx, v);
#line 681 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, INTVAL value)
{
#line 435 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_integer(interp, value);
    Parrot_OrderedHash_set_pmc_keyed_str(interp, _self, key, v);
#line 690 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_number_keyed(PARROT_INTERP, PMC *_self, PMC *key, FLOATVAL value)
{
#line 393 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_number(interp, value);
    VTABLE_set_pmc_keyed(interp, _self, key, v);
#line 699 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, FLOATVAL value)
{
#line 602 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_new(interp, Parrot_hll_get_ctx_HLL_type(interp,
                enum_class_Float));
    VTABLE_set_number_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, _self, idx, v);
#line 710 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, FLOATVAL value)
{
#line 440 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_number(interp, value);
    Parrot_OrderedHash_set_pmc_keyed_str(interp, _self, key, v);
#line 719 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value)
{
#line 339 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes * const attrs =
            PARROT_ORDEREDHASH(_self);

    /* Check for old entry */
    PMC *list_entry = VTABLE_get_pmc_keyed(interp, attrs->hash, key);
    if (!PMC_IS_NULL(list_entry)) {
        /* We have old entry. Just update value */
        PMC * const nextkey = Parrot_key_next(interp, key);
        if (nextkey) {
            VTABLE_set_pmc_keyed(interp, value, nextkey, value);
        }
        else
            VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE, value);
        return;
    }

    /* Create new entry */
    list_entry = Parrot_pmc_new_init_int(interp,
            enum_class_FixedPMCArray, ORDERED_HASH_ITEM_MAX);
    VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE, value);
    VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_KEY, key);

    /* .. and link it */
    if (!PMC_IS_NULL(attrs->last)) {
        VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_PREV, attrs->last);
        VTABLE_set_pmc_keyed_int(interp, attrs->last, ORDERED_HASH_ITEM_NEXT, list_entry);
    }
    attrs->last = list_entry;
    if (PMC_IS_NULL(attrs->first))
        attrs->first = list_entry;

    /* .. and store it */
    VTABLE_set_pmc_keyed(interp, attrs->hash, key, list_entry);
#line 759 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, PMC *val)
{
#line 574 "./src/pmc/orderedhash.pmc"

    const INTVAL n = Parrot_OrderedHash_elements(interp, _self);

    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;

    if (idx >= n) {
        /* TODO warn or fill if there are holes */
        STRING * const fmt = CONST_STRING(interp, "\1%d");
        STRING * const key = Parrot_sprintf_s(interp, fmt, idx);
        VTABLE_set_pmc_keyed_str(interp, _self, key, val);
    }
    else {
        PMC * const list_entry = get_list_item(interp, _self, idx);
        PARROT_ASSERT(!PMC_IS_NULL(list_entry));
        VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE, val);
    }
#line 784 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, PMC *value)
{
#line 419 "./src/pmc/orderedhash.pmc"

    /* Wallpapering problem with HLL Strings as keys */
    /* Apparently HLL registry in Parrot uses OrderedHash */
    /* Now we have chicken and egg problem during freeze/thaw */
    /* When we try to thaw OrderedHash which stores HLL mapping */
    /* Reported by François Perrad */
    PMC * const pkey = Parrot_pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, pkey, key);
    VTABLE_set_pmc_keyed(interp, _self, pkey, value);
#line 799 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_string_keyed(PARROT_INTERP, PMC *_self, PMC *key, STRING *value)
{
#line 398 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_box_string(interp, value);
    VTABLE_set_pmc_keyed(interp, _self, key, v);
#line 808 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL idx, STRING *value)
{
#line 609 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_new(interp, Parrot_hll_get_ctx_HLL_type(interp,
                enum_class_String));
    VTABLE_set_string_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, _self, idx, v);
#line 819 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_string_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, STRING *value)
{
#line 430 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_box_string(interp, value);
    Parrot_OrderedHash_set_pmc_keyed_str(interp, _self, key, v);
#line 828 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_thawfinish(PARROT_INTERP, PMC *_self, PMC *info)
{
#line 827 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes *attrs = PARROT_ORDEREDHASH(_self);
    find_bounds(interp, attrs->hash, &attrs->first, &attrs->last);
    interp->vtables[enum_class_default]->thawfinish(interp, _self, info);
#line 838 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_visit(PARROT_INTERP, PMC *_self, PMC *info)
{
#line 822 "./src/pmc/orderedhash.pmc"

    VISIT_PMC_ATTR(interp, info, _self, OrderedHash, hash);
    interp->vtables[enum_class_default]->visit(interp, _self, info);
#line 847 "./src/pmc/orderedhash.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_OrderedHash_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_OrderedHash_clone;
    vt->defined_keyed = Parrot_OrderedHash_defined_keyed;
    vt->defined_keyed_int = Parrot_OrderedHash_defined_keyed_int;
    vt->delete_keyed = Parrot_OrderedHash_delete_keyed;
    vt->delete_keyed_int = Parrot_OrderedHash_delete_keyed_int;
    vt->delete_keyed_str = Parrot_OrderedHash_delete_keyed_str;
    vt->elements = Parrot_OrderedHash_elements;
    vt->exists_keyed = Parrot_OrderedHash_exists_keyed;
    vt->exists_keyed_int = Parrot_OrderedHash_exists_keyed_int;
    vt->exists_keyed_str = Parrot_OrderedHash_exists_keyed_str;
    vt->get_integer = Parrot_OrderedHash_get_integer;
    vt->get_integer_keyed = Parrot_OrderedHash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_OrderedHash_get_integer_keyed_int;
    vt->get_iter = Parrot_OrderedHash_get_iter;
    vt->get_number = Parrot_OrderedHash_get_number;
    vt->get_number_keyed = Parrot_OrderedHash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_OrderedHash_get_number_keyed_int;
    vt->get_pmc = Parrot_OrderedHash_get_pmc;
    vt->get_pmc_keyed = Parrot_OrderedHash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_OrderedHash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_OrderedHash_get_pmc_keyed_str;
    vt->get_string_keyed = Parrot_OrderedHash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_OrderedHash_get_string_keyed_int;
    vt->init = Parrot_OrderedHash_init;
    vt->mark = Parrot_OrderedHash_mark;
    vt->push_float = Parrot_OrderedHash_push_float;
    vt->push_integer = Parrot_OrderedHash_push_integer;
    vt->push_pmc = Parrot_OrderedHash_push_pmc;
    vt->push_string = Parrot_OrderedHash_push_string;
    vt->set_integer_keyed = Parrot_OrderedHash_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_OrderedHash_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_OrderedHash_set_integer_keyed_str;
    vt->set_number_keyed = Parrot_OrderedHash_set_number_keyed;
    vt->set_number_keyed_int = Parrot_OrderedHash_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_OrderedHash_set_number_keyed_str;
    vt->set_pmc_keyed = Parrot_OrderedHash_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_OrderedHash_set_pmc_keyed_int;
    vt->set_pmc_keyed_str = Parrot_OrderedHash_set_pmc_keyed_str;
    vt->set_string_keyed = Parrot_OrderedHash_set_string_keyed;
    vt->set_string_keyed_int = Parrot_OrderedHash_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_OrderedHash_set_string_keyed_str;
    vt->thawfinish = Parrot_OrderedHash_thawfinish;
    vt->visit = Parrot_OrderedHash_visit;
    vt->attr_size = sizeof(Parrot_OrderedHash_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_OrderedHash_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_OrderedHash_clone;
    vt->defined_keyed = Parrot_OrderedHash_defined_keyed;
    vt->defined_keyed_int = Parrot_OrderedHash_defined_keyed_int;
    vt->elements = Parrot_OrderedHash_elements;
    vt->exists_keyed = Parrot_OrderedHash_exists_keyed;
    vt->exists_keyed_int = Parrot_OrderedHash_exists_keyed_int;
    vt->exists_keyed_str = Parrot_OrderedHash_exists_keyed_str;
    vt->get_integer = Parrot_OrderedHash_get_integer;
    vt->get_integer_keyed = Parrot_OrderedHash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_OrderedHash_get_integer_keyed_int;
    vt->get_iter = Parrot_OrderedHash_get_iter;
    vt->get_number = Parrot_OrderedHash_get_number;
    vt->get_number_keyed = Parrot_OrderedHash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_OrderedHash_get_number_keyed_int;
    vt->get_pmc = Parrot_OrderedHash_get_pmc;
    vt->get_pmc_keyed = Parrot_OrderedHash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_OrderedHash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_OrderedHash_get_pmc_keyed_str;
    vt->get_string_keyed = Parrot_OrderedHash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_OrderedHash_get_string_keyed_int;
    vt->init = Parrot_OrderedHash_init;
    vt->mark = Parrot_OrderedHash_mark;
    vt->visit = Parrot_OrderedHash_visit;
    vt->attr_size = sizeof(Parrot_OrderedHash_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OrderedHash_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_OrderedHash_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OrderedHash_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_OrderedHash_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_OrderedHash_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "OrderedHash", 11,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_OrderedHash_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "OrderedHash")), PMCNULL);
    return isa;
}

void
Parrot_OrderedHash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fhash Ffirst Flast ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_OrderedHash_get_vtable(interp);
        vt->base_type      = enum_class_OrderedHash;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "OrderedHash");
        vt->provides_str = CONST_STRING_GEN(interp, "array hash");
        vt->isa_hash     = Parrot_OrderedHash_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_OrderedHash_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_OrderedHash;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_OrderedHash_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_OrderedHash_class_init */
#line 847 "./src/pmc/orderedhash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
