/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablestringarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_resizablestringarray.h"
#include "pmc_fixedstringarray.h"
#include "pmc_default.h"
#include "resizablestringarray.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/resizablestringarray.pmc"
/*
Copyright (C) 2001-2010, Parrot Foundation.

=head1 NAME

src/pmc/resizablestringarray.pmc - resizable array for strings only

=head1 DESCRIPTION

ResizableStringArray implements a resizeable array which stores Parrot strings
only. Any ints or floats assigned to elements of the array will first be
converted to String PMCs and then to native Parrot strings.  PMCs assigned to
to elements of the array will be stringified by having their C<get_string>
method called.

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 47 "./src/pmc/resizablestringarray.c"
static  PMC  * Parrot_ResizableStringArray_clone(PARROT_INTERP, PMC *_self);
static  void  Parrot_ResizableStringArray_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  void  Parrot_ResizableStringArray_delete_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  STRING  * Parrot_ResizableStringArray_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  FLOATVAL  Parrot_ResizableStringArray_pop_float(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_ResizableStringArray_pop_integer(PARROT_INTERP, PMC *_self);
static  PMC  * Parrot_ResizableStringArray_pop_pmc(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_ResizableStringArray_pop_string(PARROT_INTERP, PMC *_self);
static  void  Parrot_ResizableStringArray_push_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_ResizableStringArray_push_integer(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_ResizableStringArray_push_pmc(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_ResizableStringArray_push_string(PARROT_INTERP, PMC *_self, STRING *value);
static  void  Parrot_ResizableStringArray_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL new_size);
static  void  Parrot_ResizableStringArray_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, STRING *value);
static  FLOATVAL  Parrot_ResizableStringArray_shift_float(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_ResizableStringArray_shift_integer(PARROT_INTERP, PMC *_self);
static  PMC  * Parrot_ResizableStringArray_shift_pmc(PARROT_INTERP, PMC *_self);
static  STRING  * Parrot_ResizableStringArray_shift_string(PARROT_INTERP, PMC *_self);
static  void  Parrot_ResizableStringArray_splice(PARROT_INTERP, PMC *_self, PMC *value, INTVAL offset, INTVAL count);
static  void  Parrot_ResizableStringArray_unshift_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_ResizableStringArray_unshift_integer(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_ResizableStringArray_unshift_pmc(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_ResizableStringArray_unshift_string(PARROT_INTERP, PMC *_self, STRING *value);
static  void Parrot_ResizableStringArray_nci_shift(PARROT_INTERP, PMC *_self);
static  void Parrot_ResizableStringArray_nci_pop(PARROT_INTERP, PMC *_self);
static  void Parrot_ResizableStringArray_nci_unshift(PARROT_INTERP, PMC *_self);
static  void Parrot_ResizableStringArray_nci_push(PARROT_INTERP, PMC *_self);
void    Parrot_ResizableStringArray_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableStringArray_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableStringArray_get_vtable(PARROT_INTERP);
void    Parrot_ResizableStringArray_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableStringArray_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableStringArray_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_ResizableStringArray_clone(PARROT_INTERP, PMC *_self)
{
#line 269 "./src/pmc/resizablestringarray.pmc"

    PMC * const copy = interp->vtables[enum_class_FixedStringArray]->clone(interp, _self);
    INTVAL size;
    GETATTR_ResizableStringArray_size(interp, _self, size);
    /* copy trimmed extra space */
    SETATTR_ResizableStringArray_resize_threshold(interp, copy, size);
    return copy;
#line 92 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_delete_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 534 "./src/pmc/resizablestringarray.pmc"

    const INTVAL idx = VTABLE_get_integer(interp, key);
    STRING  **str_array;
    UINTVAL   size, i;

    GETATTR_ResizableStringArray_str_array(interp, _self, str_array);
    GETATTR_ResizableStringArray_size(interp, _self, size);

    for (i = idx; i < size - 1; ++i)
        str_array[i] = str_array[i + 1];

    VTABLE_set_integer_native(interp, _self, size - 1);
#line 110 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_delete_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 511 "./src/pmc/resizablestringarray.pmc"

    STRING  **str_array;
    UINTVAL   size, i;

    GETATTR_ResizableStringArray_str_array(interp, _self, str_array);
    GETATTR_ResizableStringArray_size(interp, _self, size);

    for (i = key; i < size - 1; ++i)
        str_array[i] = str_array[i + 1];

    VTABLE_set_integer_native(interp, _self, size - 1);
#line 127 "./src/pmc/resizablestringarray.c"
}
static  STRING  *
Parrot_ResizableStringArray_get_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 41 "./src/pmc/resizablestringarray.pmc"


    STRING **str_array;
    INTVAL size;
    GETATTR_ResizableStringArray_size(interp, _self, size);

    if (key < 0) {
        if (key < -size)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }

    if (key >= size)
        return CONST_STRING(interp, "");

    GETATTR_ResizableStringArray_str_array(interp, _self, str_array);

    if (!str_array[key])
        str_array[key] = Parrot_str_new(interp, NULL, 0);

    return str_array[key];
#line 156 "./src/pmc/resizablestringarray.c"
}
static  FLOATVAL 
Parrot_ResizableStringArray_pop_float(PARROT_INTERP, PMC *_self)
{
#line 182 "./src/pmc/resizablestringarray.pmc"

    PMC * const pmcval = VTABLE_pop_pmc(interp, _self);
    return VTABLE_get_number(interp, pmcval);
#line 165 "./src/pmc/resizablestringarray.c"
}
static  INTVAL 
Parrot_ResizableStringArray_pop_integer(PARROT_INTERP, PMC *_self)
{
#line 167 "./src/pmc/resizablestringarray.pmc"

    PMC * const pmcval = VTABLE_pop_pmc(interp, _self);
    return VTABLE_get_integer(interp, pmcval);
#line 174 "./src/pmc/resizablestringarray.c"
}
static  PMC  *
Parrot_ResizableStringArray_pop_pmc(PARROT_INTERP, PMC *_self)
{
#line 148 "./src/pmc/resizablestringarray.pmc"

    STRING *strval = VTABLE_pop_string(interp, _self);
    PMC    *value  = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, value, strval);

    return value;
#line 187 "./src/pmc/resizablestringarray.c"
}
static  STRING  *
Parrot_ResizableStringArray_pop_string(PARROT_INTERP, PMC *_self)
{
#line 124 "./src/pmc/resizablestringarray.pmc"

    STRING *value;
    INTVAL  size;
    GETATTR_ResizableStringArray_size(interp, _self, size);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't pop from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, _self, size - 1);
    VTABLE_set_integer_native(interp, _self, size - 1);
    return value;
#line 205 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_push_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 380 "./src/pmc/resizablestringarray.pmc"

    PMC    * const ret = Parrot_pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_push_string(interp, _self, val);
#line 218 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_push_integer(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 360 "./src/pmc/resizablestringarray.pmc"

    PMC    * const ret = Parrot_pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_push_string(interp, _self, val);
#line 231 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_push_pmc(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 344 "./src/pmc/resizablestringarray.pmc"

    STRING * const strvalue = VTABLE_get_string(interp, value);
    VTABLE_push_string(interp, _self, strvalue);
#line 240 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_push_string(PARROT_INTERP, PMC *_self, STRING *value)
{
#line 108 "./src/pmc/resizablestringarray.pmc"

    INTVAL next_idx;
    GETATTR_ResizableStringArray_size(interp, _self, next_idx);
    VTABLE_set_string_keyed_int(interp, _self, next_idx, value);
#line 250 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL new_size)
{
#line 197 "./src/pmc/resizablestringarray.pmc"


    STRING **str_array;
    INTVAL   resize_threshold;

    if (new_size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't resize!");

    GETATTR_ResizableStringArray_str_array(interp, _self, str_array);
    GETATTR_ResizableStringArray_resize_threshold(interp, _self, resize_threshold);
    if (!str_array) {
        /* empty - used fixed routine */
        if (new_size < 8) {
            interp->vtables[enum_class_FixedStringArray]->set_integer_native(interp, _self, 8);
            SETATTR_ResizableStringArray_size(interp, _self, new_size);
            SETATTR_ResizableStringArray_resize_threshold(interp, _self, 8);
        }
        else {
            interp->vtables[enum_class_FixedStringArray]->set_integer_native(interp, _self, new_size);
            SETATTR_ResizableStringArray_resize_threshold(interp, _self, new_size);
        }
    }
    else if (new_size <= resize_threshold) {
        /* zero out anything that was previously allocated
         * if we're growing the array */
        INTVAL old_size;
        GETATTR_ResizableStringArray_size(interp, _self, old_size);
        if (new_size > old_size) {
            INTVAL i;
            for (i = old_size; i < new_size; ++i)
                str_array[i] = NULL;
        }

        SETATTR_ResizableStringArray_size(interp, _self, new_size);
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i   = resize_threshold;
        INTVAL cur = i;

        if (cur < 8192)
            cur = (new_size < 2 * cur) ? (2 * cur) : new_size;
        else {
            cur = new_size + 4096;
            cur &= ~0xfff;
        }

        SETATTR_ResizableStringArray_str_array(interp, _self,
                mem_gc_realloc_n_typed_zeroed(interp, str_array,
                        cur, resize_threshold, STRING*));
        GETATTR_ResizableStringArray_str_array(interp, _self, str_array);

        for (; i < cur; ++i)
            str_array[i] = NULL;

        SETATTR_ResizableStringArray_size(interp, _self, new_size);
        SETATTR_ResizableStringArray_resize_threshold(interp, _self, cur);
    }
#line 316 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_set_string_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, STRING *value)
{
#line 76 "./src/pmc/resizablestringarray.pmc"


    STRING **str_array;
    INTVAL   size;
    GETATTR_ResizableStringArray_size(interp, _self, size);

    if (key < 0) {
        if (key < -size)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }

    if (key >= size)
        VTABLE_set_integer_native(interp, _self, key+1);

    GETATTR_ResizableStringArray_str_array(interp, _self, str_array);
    str_array[key] = value;
#line 341 "./src/pmc/resizablestringarray.c"
}
static  FLOATVAL 
Parrot_ResizableStringArray_shift_float(PARROT_INTERP, PMC *_self)
{
#line 327 "./src/pmc/resizablestringarray.pmc"

    PMC * const pmcval = VTABLE_shift_pmc(interp, _self);
    return VTABLE_get_number(interp, pmcval);
#line 350 "./src/pmc/resizablestringarray.c"
}
static  INTVAL 
Parrot_ResizableStringArray_shift_integer(PARROT_INTERP, PMC *_self)
{
#line 312 "./src/pmc/resizablestringarray.pmc"

    PMC * const pmcval = VTABLE_shift_pmc(interp, _self);
    return VTABLE_get_integer(interp, pmcval);
#line 359 "./src/pmc/resizablestringarray.c"
}
static  PMC  *
Parrot_ResizableStringArray_shift_pmc(PARROT_INTERP, PMC *_self)
{
#line 399 "./src/pmc/resizablestringarray.pmc"

    UINTVAL  size;
    PMC     *ret;
    STRING  *value;

    GETATTR_ResizableStringArray_size(interp, _self, size);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't shift from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, _self, 0);
    ret   = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, ret, value);
    VTABLE_delete_keyed_int(interp, _self, 0);

    return ret;
#line 383 "./src/pmc/resizablestringarray.c"
}
static  STRING  *
Parrot_ResizableStringArray_shift_string(PARROT_INTERP, PMC *_self)
{
#line 288 "./src/pmc/resizablestringarray.pmc"

    STRING *value;
    INTVAL  size;
    GETATTR_ResizableStringArray_size(interp, _self, size);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't shift from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, _self, 0);
    VTABLE_delete_keyed_int(interp, _self, 0);
    return value;
#line 401 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_splice(PARROT_INTERP, PMC *_self, PMC *value, INTVAL offset, INTVAL count)
{
#line 564 "./src/pmc/resizablestringarray.pmc"


    INTVAL length, elems, shift, i;

    if (value->vtable->base_type != _self->vtable->base_type &&
            value->vtable->base_type != enum_class_FixedStringArray)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "ResizableStringArray: illegal type for splice!");

    length = VTABLE_elements(interp, _self);
    elems  = VTABLE_elements(interp, value);
    shift  = elems - count;

    /* start from end? */
    if (offset < 0)
        offset += length;

    if (offset < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "illegal splice offset\n");

    /* shrink the array */
    if (shift < 0) {
        /* start at offset so we don't overwrite values we'll need */
        for (i = offset+count; i < length; ++i)
            VTABLE_set_pmc_keyed_int(interp, _self, i + shift,
                VTABLE_get_pmc_keyed_int(interp, _self, i));

        VTABLE_set_integer_native(interp, _self, length + shift);
    }
    /* grow the array */
    else if (shift > 0) {
        VTABLE_set_integer_native(interp, _self, length + shift);

        /* move the existing values */
        /* start at length-1 so we don't overwrite values we'll need */
        for (i = length - 1; i >= offset; --i)
            VTABLE_set_pmc_keyed_int(interp, _self, i + shift,
                VTABLE_get_pmc_keyed_int(interp, _self, i));
    }

    /* copy the new values */
    for (i = 0; i < elems; ++i)
        VTABLE_set_pmc_keyed_int(interp, _self, i + offset,
            VTABLE_get_pmc_keyed_int(interp, value, i));
#line 452 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_unshift_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 492 "./src/pmc/resizablestringarray.pmc"

    PMC    * const ret = Parrot_pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_unshift_string(interp, _self, val);
#line 465 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_unshift_integer(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 472 "./src/pmc/resizablestringarray.pmc"

    PMC    * const ret = Parrot_pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_unshift_string(interp, _self, val);
#line 478 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_unshift_pmc(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 456 "./src/pmc/resizablestringarray.pmc"

    STRING * const strvalue = VTABLE_get_string(interp, value);
    VTABLE_unshift_string(interp, _self, strvalue);
#line 487 "./src/pmc/resizablestringarray.c"
}
static  void 
Parrot_ResizableStringArray_unshift_string(PARROT_INTERP, PMC *_self, STRING *value)
{
#line 430 "./src/pmc/resizablestringarray.pmc"

    STRING  **str_array;
    UINTVAL   size, i;

    GETATTR_ResizableStringArray_size(interp, _self, size);
    VTABLE_set_integer_native(interp, _self, size + 1);

    GETATTR_ResizableStringArray_str_array(interp, _self, str_array);
    for (i = size; i; --i)
        str_array[i] = str_array[i - 1];

    VTABLE_set_string_keyed_int(interp, _self, 0, value);
#line 505 "./src/pmc/resizablestringarray.c"
}
static  void
Parrot_ResizableStringArray_nci_shift(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 516 "./src/pmc/resizablestringarray.pmc"
PMC* _self;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 624 "./src/pmc/resizablestringarray.pmc"

    PMC * const value = _self->vtable->shift_pmc(interp, _self);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *value */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)value);
    return;
    /*END RETURN PMC *value */
    }
#line 626 "./src/pmc/resizablestringarray.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 543 "./src/pmc/resizablestringarray.c"
}
static  void
Parrot_ResizableStringArray_nci_pop(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 554 "./src/pmc/resizablestringarray.pmc"
PMC* _self;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 629 "./src/pmc/resizablestringarray.pmc"

    PMC * const value = _self->vtable->pop_pmc(interp, _self);
    #line 259 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *value */
#line 266 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)value);
    return;
    /*END RETURN PMC *value */
    }
#line 631 "./src/pmc/resizablestringarray.pmc"

#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 581 "./src/pmc/resizablestringarray.c"
}
static  void
Parrot_ResizableStringArray_nci_unshift(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 592 "./src/pmc/resizablestringarray.pmc"
PMC* _self;
PMC* value;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &value);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 646 "./src/pmc/resizablestringarray.pmc"

    _self->vtable->unshift_pmc(interp, _self, value);
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 609 "./src/pmc/resizablestringarray.c"
}
static  void
Parrot_ResizableStringArray_nci_push(PARROT_INTERP, PMC *_self)
{
#line 420 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 620 "./src/pmc/resizablestringarray.pmc"
PMC* _self;
PMC* value;

#line 428 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &value);
#line 432 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 650 "./src/pmc/resizablestringarray.pmc"

    _self->vtable->push_pmc(interp, _self, value);
#line 439 "/builddir/build/BUILD/parrot-3.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 637 "./src/pmc/resizablestringarray.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizableStringArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizableStringArray_clone;
    vt->delete_keyed = Parrot_ResizableStringArray_delete_keyed;
    vt->delete_keyed_int = Parrot_ResizableStringArray_delete_keyed_int;
    vt->get_string_keyed_int = Parrot_ResizableStringArray_get_string_keyed_int;
    vt->pop_float = Parrot_ResizableStringArray_pop_float;
    vt->pop_integer = Parrot_ResizableStringArray_pop_integer;
    vt->pop_pmc = Parrot_ResizableStringArray_pop_pmc;
    vt->pop_string = Parrot_ResizableStringArray_pop_string;
    vt->push_float = Parrot_ResizableStringArray_push_float;
    vt->push_integer = Parrot_ResizableStringArray_push_integer;
    vt->push_pmc = Parrot_ResizableStringArray_push_pmc;
    vt->push_string = Parrot_ResizableStringArray_push_string;
    vt->set_integer_native = Parrot_ResizableStringArray_set_integer_native;
    vt->set_string_keyed_int = Parrot_ResizableStringArray_set_string_keyed_int;
    vt->shift_float = Parrot_ResizableStringArray_shift_float;
    vt->shift_integer = Parrot_ResizableStringArray_shift_integer;
    vt->shift_pmc = Parrot_ResizableStringArray_shift_pmc;
    vt->shift_string = Parrot_ResizableStringArray_shift_string;
    vt->splice = Parrot_ResizableStringArray_splice;
    vt->unshift_float = Parrot_ResizableStringArray_unshift_float;
    vt->unshift_integer = Parrot_ResizableStringArray_unshift_integer;
    vt->unshift_pmc = Parrot_ResizableStringArray_unshift_pmc;
    vt->unshift_string = Parrot_ResizableStringArray_unshift_string;
    vt->attr_size = sizeof(Parrot_ResizableStringArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizableStringArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizableStringArray_clone;
    vt->get_string_keyed_int = Parrot_ResizableStringArray_get_string_keyed_int;
    vt->attr_size = sizeof(Parrot_ResizableStringArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableStringArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedStringArray_get_vtable(interp);
    Parrot_ResizableStringArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableStringArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedStringArray_ro_get_vtable(interp);
    Parrot_ResizableStringArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizableStringArray_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedStringArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "ResizableStringArray", 20,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizableStringArray_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_FixedStringArray_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizableStringArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizableStringArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":str_array :size :resize_threshold ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizableStringArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizableStringArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizableStringArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizableStringArray_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ResizableStringArray_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ResizableStringArray;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizableStringArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "shift");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizableStringArray_nci_shift),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "pop");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizableStringArray_nci_pop),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "unshift");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizableStringArray_nci_unshift),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "push");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizableStringArray_nci_push),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_ResizableStringArray_class_init */
#line 653 "./src/pmc/resizablestringarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
